# coding: utf-8

"""
    Honeywell

    This is an api to connect to the Honeywell backend  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: nick@aliroquantum.com
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from aliro_honeywell.api_client import ApiClient
from aliro_honeywell.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class MeteringApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def metering_get(self, **kwargs):  # noqa: E501
        """Metering API is used to retrieve information about the jobs run and the number of QCU consumed within specific period of time. Metering requests can use date range, last X number of days or last Y number of jobs.   # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.metering_get(async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param str start: <start> and <end> are startand end dates for the metering report. The dates are specified in the YYYY-MM-DD format. Start date cannot be further than 40 days in the past. 
        :param str end: <start> and <end> are startand end dates for the metering report. The dates are specified in the YYYY-MM-DD format. 
        :param int days: <days> is the number of days in the past starting from today. Days can be between 1 and 40. 
        :param int jobs: <jobs>is the number of last jobs submitted. Jobs can be between 1 and 100. 
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: InlineResponse2003
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        return self.metering_get_with_http_info(**kwargs)  # noqa: E501

    def metering_get_with_http_info(self, **kwargs):  # noqa: E501
        """Metering API is used to retrieve information about the jobs run and the number of QCU consumed within specific period of time. Metering requests can use date range, last X number of days or last Y number of jobs.   # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.metering_get_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param str start: <start> and <end> are startand end dates for the metering report. The dates are specified in the YYYY-MM-DD format. Start date cannot be further than 40 days in the past. 
        :param str end: <start> and <end> are startand end dates for the metering report. The dates are specified in the YYYY-MM-DD format. 
        :param int days: <days> is the number of days in the past starting from today. Days can be between 1 and 40. 
        :param int jobs: <jobs>is the number of last jobs submitted. Jobs can be between 1 and 100. 
        :param _return_http_data_only: response data without head status code
                                       and headers
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: tuple(InlineResponse2003, status_code(int), headers(HTTPHeaderDict))
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = [
            'start',
            'end',
            'days',
            'jobs'
        ]
        all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout'
            ]
        )

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method metering_get" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'start' in local_var_params and local_var_params['start'] is not None:  # noqa: E501
            query_params.append(('start', local_var_params['start']))  # noqa: E501
        if 'end' in local_var_params and local_var_params['end'] is not None:  # noqa: E501
            query_params.append(('end', local_var_params['end']))  # noqa: E501
        if 'days' in local_var_params and local_var_params['days'] is not None:  # noqa: E501
            query_params.append(('days', local_var_params['days']))  # noqa: E501
        if 'jobs' in local_var_params and local_var_params['jobs'] is not None:  # noqa: E501
            query_params.append(('jobs', local_var_params['jobs']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['JwtKeyAuth']  # noqa: E501

        return self.api_client.call_api(
            '/metering', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2003',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)
